#include <SFML/Graphics.hpp>

class Effect : public sf::Drawable, sf::Transformable {
public:
	Effect() : fadingCounter(0){}
	~Effect(){}
	bool update() {

		if(fadingCounter >= 256)
			return true;

		const int cubeSize = 8;
		const int width = 800;
		const int height = 600;

		const int nbWidth = width/cubeSize;
		const int nbHeight = height/cubeSize;

		vertices.setPrimitiveType(sf::Quads);
		vertices.resize(nbHeight*nbWidth*4);
		sf::Color color;

		for(int i = 0; i < nbWidth; i++) {
			for(int j = 0; j < nbHeight; j++) {

				color.r = static_cast<sf::Uint8>(rand()%(256 - fadingCounter) + fadingCounter);
				color.g = static_cast<sf::Uint8>(rand()%(256 - fadingCounter) + fadingCounter);
				color.b = static_cast<sf::Uint8>(rand()%(256 - fadingCounter) + fadingCounter);

				sf::Vertex* quad = &vertices[(i + j * nbWidth) * 4];

				quad[0].position = sf::Vector2f((float)(i * cubeSize), (float)(j * cubeSize));
				quad[1].position = sf::Vector2f((float)(i * cubeSize + cubeSize), (float)(j * cubeSize));
				quad[2].position = sf::Vector2f((float)(i * cubeSize + cubeSize), (float)(j * cubeSize + cubeSize));
				quad[3].position = sf::Vector2f((float)(i * cubeSize), (float)(j * cubeSize + cubeSize));

				quad[0].color = color;
				quad[1].color = color;
				quad[2].color = color;
				quad[3].color = color;
			}
		}

		fadingCounter += 2;
		return false;
	}
private:
	virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const {
		states.transform *= getTransform();
		target.draw(vertices, states);
	}

	sf::VertexArray vertices;
	int fadingCounter;
}; 