#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>
#include "Effect.h"
#include <iostream>

int main()
{
	sf::RenderWindow window(sf::VideoMode(800, 600), "Mind");
	sf::View view;
	view.setSize(800, 600);
	view.setCenter(400, 300);
	window.setView(view);
	window.setFramerateLimit(60);

	sf::Music music;
	music.openFromFile("data/music/restless.ogg");
		//window.close();
	music.setVolume(100);
	music.play();

	sf::Texture icon;
	icon.loadFromFile("data/img/icon.png");
	window.setIcon(32, 32, icon.copyToImage().getPixelsPtr());

	int counterEffect = 0;
	bool end = false;

	Effect eff;

	sf::Texture backgroundTex;
	backgroundTex.loadFromFile("data/img/background.png");

	sf::Texture persoTex;
	persoTex.loadFromFile("data/img/pers.png");

	sf::Texture fragTex;
	fragTex.loadFromFile("data/img/frag.png");

	sf::IntRect rectTop(0, 0, 36, 75);
	sf::IntRect rectRight(36, 0, 75, 36);
	sf::IntRect rectLeft(36, 36, 75, 36);
	sf::IntRect current;
	current = rectTop;

	int width = 36;
	int height = 75;

	sf::Font font;
	if(!font.loadFromFile("data/font/georgia.ttf")) {
		window.close();
	}

	sf::Text text;
	text.setString("The End");
	text.setFont(font);
	text.setCharacterSize(50);
	text.setPosition(300, 250);
	text.setColor(sf::Color::Black);

	sf::Sprite background;
	background.setTexture(backgroundTex);
	background.setPosition(0, 0);

	sf::Sprite perso;
	sf::Vector2f pos(400, (float)(2400 - height));
	perso.setTexture(persoTex);
	perso.setTextureRect(rectTop);

	sf::Sprite frag;
	frag.setTexture(fragTex);

	const int numberFrag = 23;
	const int speed = 1;

	int counterFrag = 0;

	sf::IntRect fragPos[numberFrag];
	bool fragActivated[numberFrag];

	for(int i = 0; i < numberFrag; i++) {
		fragActivated[i] = true;
		fragPos[i] = sf::IntRect(rand() % 800, rand() % 2400, 6, 6);
	}

	while (window.isOpen()) {
		sf::Event event;

		if(counterFrag == numberFrag)
			counterEffect++;

		if(counterFrag != numberFrag) {
			if(sf::Keyboard::isKeyPressed(sf::Keyboard::Left)) {
				current = rectLeft;
				pos.x -= speed;
			}
			else if(sf::Keyboard::isKeyPressed(sf::Keyboard::Right)) {
				current = rectRight;
				pos.x += speed;
			}
			else if(sf::Keyboard::isKeyPressed(sf::Keyboard::Up)) {
				current = rectTop;
				pos.y -= speed;
			}
			else if(sf::Keyboard::isKeyPressed(sf::Keyboard::Down)) {
				current = rectTop;
				pos.y += speed;
			}
		}


		while (window.pollEvent(event)) {
			if (event.type == sf::Event::Closed)
				window.close();
			if(event.type == sf::Event::KeyReleased)
				if(event.key.code == sf::Keyboard::Escape)
					window.close();
		}
		
		view.setCenter(400, 300);

		if(pos.x > 800 -height)
			pos.x = (float)(800 - height);
		if(pos.x < 0)
			pos.x = 0;
		if(pos.y < 0)
			pos.y = 0;

		if(counterFrag == numberFrag) {
			if(pos.y > 600 - height)
				pos.y = (float)(600 - height);
		}
		else {
			
			if(pos.y > 600)
				view.setCenter(400, 900);
			if(pos.y > 1200)
				view.setCenter(400, 1500);
			if(pos.y > 1800)
				view.setCenter(400, 2100);
			if(pos.y > 2400 - height)
				pos.y = (float)(2400 - height);

		}
		for(int i = 0; i < numberFrag; i++) {
			sf::IntRect block((int)perso.getPosition().x, (int)perso.getPosition().y, width, height);
			if(block.intersects(fragPos[i])) {
				if(fragActivated[i]) {
					fragActivated[i] = false;
					counterFrag++;
					if(counterFrag == numberFrag) {
						i = numberFrag;
						//std::cout << counterFrag << "\n";
						pos.x = 400;
						pos.y = 300;
						eff.update();
					}
				}
			}
		}

		window.setView(view);

		window.clear();

		if(counterFrag == numberFrag) {
			if(counterEffect == 8) {
				if(eff.update()) {
					end = true;
				}
				counterEffect = 0;
			}
			
			window.draw(eff);
		}
		else {
			window.draw(background);

			for(int i = 0; i < numberFrag; i++) {
				if(fragActivated[i]) {
					frag.setPosition(sf::Vector2f((float)fragPos[i].left, (float)fragPos[i].top));
					window.draw(frag);
				}
			}
		}


		

		perso.setTextureRect(current);
		perso.setPosition(pos);
		window.draw(perso);

		//sf::RectangleShape r;
		//r.setPosition((float)current.left, (float)current.top);
		//r.setSize(sf::Vector2f((float)current.width, (float)current.height));
		//r.setOutlineColor(sf::Color::White);
		//r.setOutlineThickness(3.0f);

		//window.draw(r);
		if(end) {
			window.draw(text);
		}
		window.display();
	}

	return 0;
}